diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/dcmrecv.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/dcmrecv.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/dcmrecv.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/dcmrecv.cc	2017-12-18 09:53:14.249431248 +0100
@@ -266,8 +266,8 @@
     storageSCP.setPort(OFstatic_cast(Uint16, opt_port));
     storageSCP.setAETitle(opt_aeTitle);
     storageSCP.setMaxReceivePDULength(OFstatic_cast(Uint32, opt_maxPDULength));
-    storageSCP.setACSETimeout(OFstatic_cast(Uint32, opt_acseTimeout));
-    storageSCP.setDIMSETimeout(OFstatic_cast(Uint32, opt_dimseTimeout));
+    storageSCP.setACSETimeout(OFstatic_cast(OFTimeValue, opt_acseTimeout));
+    storageSCP.setDIMSETimeout(OFstatic_cast(OFTimeValue, opt_dimseTimeout));
     storageSCP.setDIMSEBlockingMode(opt_blockingMode);
     storageSCP.setVerbosePCMode(opt_showPresentationContexts);
     storageSCP.setRespondWithCalledAETitle(opt_useCalledAETitle);
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/dcmsend.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/dcmsend.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/dcmsend.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/dcmsend.cc	2017-12-18 09:54:14.868150653 +0100
@@ -334,7 +334,7 @@
         if (cmd.findOption("--timeout"))
         {
             app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-            dcmConnectionTimeout.set(OFstatic_cast(Sint32, opt_timeout));
+            dcmConnectionTimeout.set(OFstatic_cast(OFTimeValue, opt_timeout));
         }
         if (cmd.findOption("--acse-timeout"))
             app.checkValue(cmd.getValueAndCheckMin(opt_acseTimeout, 1));
@@ -460,8 +460,8 @@
     storageSCU.setPeerAETitle(opt_peerTitle);
     storageSCU.setAETitle(opt_ourTitle);
     storageSCU.setMaxReceivePDULength(OFstatic_cast(Uint32, opt_maxReceivePDULength));
-    storageSCU.setACSETimeout(OFstatic_cast(Uint32, opt_acseTimeout));
-    storageSCU.setDIMSETimeout(OFstatic_cast(Uint32, opt_dimseTimeout));
+    storageSCU.setACSETimeout(OFstatic_cast(OFTimeValue, opt_acseTimeout));
+    storageSCU.setDIMSETimeout(OFstatic_cast(OFTimeValue, opt_dimseTimeout));
     storageSCU.setDIMSEBlockingMode(opt_blockMode);
     storageSCU.setVerbosePCMode(opt_showPresentationContexts);
     storageSCU.setDatasetConversionMode(opt_decompressionMode != DcmStorageSCU::DM_never);
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/echoscu.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/echoscu.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/echoscu.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/echoscu.cc	2017-12-18 09:54:31.175896880 +0100
@@ -61,7 +61,7 @@
 #define PEERAPPLICATIONTITLE "ANY-SCP"
 
 static T_DIMSE_BlockingMode opt_blockMode = DIMSE_BLOCKING;
-static int opt_dimse_timeout = 0;
+static OFTimeValue opt_dimse_timeout = 0;
 
 static OFCondition cecho(T_ASC_Association * assoc, unsigned long num_repeat);
 
@@ -126,7 +126,7 @@
     OFCmdUnsignedInt opt_numPresentationCtx  = 1;
     OFCmdUnsignedInt maxXferSyntaxes         = OFstatic_cast(OFCmdUnsignedInt, (DIM_OF(transferSyntaxes)));
     OFBool           opt_secureConnection    = OFFalse; /* default: no secure connection */
-    int opt_acse_timeout = 30;
+    OFTimeValue      opt_acse_timeout = 30;
 
 #ifdef WITH_OPENSSL
     int         opt_keyFileFormat = SSL_FILETYPE_PEM;
@@ -282,21 +282,21 @@
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        dcmConnectionTimeout.set(OFstatic_cast(Sint32, opt_timeout));
+        dcmConnectionTimeout.set(OFstatic_cast(OFTimeValue, opt_timeout));
       }
 
       if (cmd.findOption("--acse-timeout"))
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        opt_acse_timeout = OFstatic_cast(int, opt_timeout);
+        opt_acse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
       }
 
       if (cmd.findOption("--dimse-timeout"))
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        opt_dimse_timeout = OFstatic_cast(int, opt_timeout);
+        opt_dimse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
         opt_blockMode = DIMSE_NONBLOCKING;
       }
 
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/findscu.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/findscu.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/findscu.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/findscu.cc	2017-12-18 09:54:01.209000200 +0100
@@ -56,10 +56,10 @@
     OFList<OFString>      fileNameList;
     OFBool                opt_abortAssociation = OFFalse;
     const char *          opt_abstractSyntax = UID_FINDModalityWorklistInformationModel;
-    int                   opt_acse_timeout = 30;
+    OFTimeValue           opt_acse_timeout = 30;
     T_DIMSE_BlockingMode  opt_blockMode = DIMSE_BLOCKING;
     OFCmdSignedInt        opt_cancelAfterNResponses = -1;
-    int                   opt_dimse_timeout = 0;
+    OFTimeValue           opt_dimse_timeout = 0;
     int                   opt_outputResponsesToLogger = 0;
     OFBool                opt_extractResponsesToFile = OFFalse;
     OFString              opt_outputDirectory = ".";
@@ -301,21 +301,21 @@
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        dcmConnectionTimeout.set(OFstatic_cast(Sint32, opt_timeout));
+        dcmConnectionTimeout.set(OFstatic_cast(OFTimeValue, opt_timeout));
       }
 
       if (cmd.findOption("--acse-timeout"))
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        opt_acse_timeout = OFstatic_cast(int, opt_timeout);
+        opt_acse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
       }
 
       if (cmd.findOption("--dimse-timeout"))
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        opt_dimse_timeout = OFstatic_cast(int, opt_timeout);
+        opt_dimse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
         opt_blockMode = DIMSE_NONBLOCKING;
       }
 
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/getscu.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/getscu.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/getscu.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/getscu.cc	2017-12-18 09:54:21.251657301 +0100
@@ -64,8 +64,8 @@
 OFCmdUnsignedInt        opt_repeatCount = 1;
 QueryModel              opt_queryModel = QMPatientRoot;
 T_DIMSE_BlockingMode    opt_blockMode = DIMSE_BLOCKING;
-int                     opt_dimse_timeout = 0;
-int                     opt_acse_timeout = 30;
+OFCmdSignedInt          opt_dimse_timeout = 0;
+OFCmdSignedInt          opt_acse_timeout = 30;
 OFString                opt_outputDirectory = ".";
 static OFList<OFString> overrideKeys;
 
@@ -269,21 +269,21 @@
     {
       OFCmdSignedInt opt_timeout = 0;
       app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-      dcmConnectionTimeout.set(OFstatic_cast(Sint32, opt_timeout));
+      dcmConnectionTimeout.set(OFstatic_cast(OFTimeValue, opt_timeout));
     }
 
     if (cmd.findOption("--acse-timeout"))
     {
       OFCmdSignedInt opt_timeout = 0;
       app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-      opt_acse_timeout = OFstatic_cast(int, opt_timeout);
+      opt_acse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
     }
 
     if (cmd.findOption("--dimse-timeout"))
     {
       OFCmdSignedInt opt_timeout = 0;
       app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-      opt_dimse_timeout = OFstatic_cast(int, opt_timeout);
+      opt_dimse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
       opt_blockMode = DIMSE_NONBLOCKING;
     }
 
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/movescu.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/movescu.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/movescu.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/movescu.cc	2017-12-18 10:02:34.733733643 +0100
@@ -118,8 +118,8 @@
 OFCmdSignedInt    opt_cancelAfterNResponses = -1;
 QueryModel        opt_queryModel = QMPatientRoot;
 T_DIMSE_BlockingMode opt_blockMode = DIMSE_BLOCKING;
-int               opt_dimse_timeout = 0;
-int               opt_acse_timeout = 30;
+OFTimeValue       opt_dimse_timeout = 0;
+OFTimeValue       opt_acse_timeout = 30;
 OFBool            opt_ignorePendingDatasets = OFTrue;
 OFString          opt_outputDirectory = ".";
 int               cmove_status_code = EXITCODE_NO_ERROR;
@@ -493,21 +493,21 @@
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        dcmConnectionTimeout.set(OFstatic_cast(Sint32, opt_timeout));
+        dcmConnectionTimeout.set(OFstatic_cast(OFTimeValue, opt_timeout));
       }
 
       if (cmd.findOption("--acse-timeout"))
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        opt_acse_timeout = OFstatic_cast(int, opt_timeout);
+        opt_acse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
       }
 
       if (cmd.findOption("--dimse-timeout"))
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        opt_dimse_timeout = OFstatic_cast(int, opt_timeout);
+        opt_dimse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
         opt_blockMode = DIMSE_NONBLOCKING;
       }
 
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/storescp.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/storescp.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/storescp.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/storescp.cc	2017-12-18 10:43:27.431961396 +0100
@@ -169,14 +169,14 @@
 
 OFString           lastStudySubdirectoryPathAndName;
 static OFBool      opt_renameOnEndOfStudy = OFFalse;  // default: don't rename any files on end of study
-static long        opt_endOfStudyTimeout = -1;        // default: no end of study timeout
+static OFTimeValue opt_endOfStudyTimeout = -1;        // default: no end of study timeout
 static OFBool      endOfStudyThroughTimeoutEvent = OFFalse;
 static const char *opt_configFile = NULL;
 static const char *opt_profileName = NULL;
 T_DIMSE_BlockingMode opt_blockMode = DIMSE_BLOCKING;
-int                opt_dimse_timeout = 0;
-int                opt_acse_timeout = 30;
-OFCmdSignedInt     opt_socket_timeout = 60;
+OFTimeValue        opt_dimse_timeout = 0;
+OFTimeValue        opt_acse_timeout = 30;
+OFTimeValue        opt_socket_timeout = 60;
 
 #if defined(HAVE_FORK) || defined(_WIN32)
 OFBool             opt_forkMode = OFFalse;
@@ -562,22 +562,26 @@
     if (opt_networkTransferSyntax != EXS_Unknown) opt_acceptAllXfers = OFFalse;
 
     if (cmd.findOption("--socket-timeout"))
-      app.checkValue(cmd.getValueAndCheckMin(opt_socket_timeout, -1));
+    {
+      OFCmdSignedInt opt_timeout = 0;
+      app.checkValue(cmd.getValueAndCheckMin(opt_timeout, -1));
+      opt_socket_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
+    }
     // always set the timeout values since the global default might be different
-    dcmSocketSendTimeout.set(OFstatic_cast(Sint32, opt_socket_timeout));
-    dcmSocketReceiveTimeout.set(OFstatic_cast(Sint32, opt_socket_timeout));
+    dcmSocketSendTimeout.set(OFstatic_cast(OFTimeValue, opt_socket_timeout));
+    dcmSocketReceiveTimeout.set(OFstatic_cast(OFTimeValue, opt_socket_timeout));
 
     if (cmd.findOption("--acse-timeout"))
     {
       OFCmdSignedInt opt_timeout = 0;
       app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-      opt_acse_timeout = OFstatic_cast(int, opt_timeout);
+      opt_acse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
     }
     if (cmd.findOption("--dimse-timeout"))
     {
       OFCmdSignedInt opt_timeout = 0;
       app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-      opt_dimse_timeout = OFstatic_cast(int, opt_timeout);
+      opt_dimse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
       opt_blockMode = DIMSE_NONBLOCKING;
     }
 
@@ -895,9 +899,11 @@
 
     if (cmd.findOption("--eostudy-timeout"))
     {
+      OFCmdSignedInt opt_timeout = -1;
       app.checkDependence("--eostudy-timeout", "--sort-conc-studies, --sort-on-study-uid, --sort-on-patientname, --exec-on-eostudy or --rename-on-eostudy",
         (opt_sortStudyMode != ESM_None) || (opt_execOnEndOfStudy != NULL) || opt_renameOnEndOfStudy);
-      app.checkValue(cmd.getValueAndCheckMin(opt_endOfStudyTimeout, 0));
+      app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 0));
+      opt_endOfStudyTimeout = OFstatic_cast(OFTimeValue, opt_timeout);
     }
 
     if (cmd.findOption("--exec-sync")) opt_execSync = OFTrue;
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/storescu.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/storescu.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/apps/storescu.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/apps/storescu.cc	2017-12-18 09:52:48.410514654 +0100
@@ -119,9 +119,9 @@
 static const char *opt_configFile = NULL;
 static const char *opt_profileName = NULL;
 T_DIMSE_BlockingMode opt_blockMode = DIMSE_BLOCKING;
-int opt_dimse_timeout = 0;
-int opt_acse_timeout = 30;
-OFCmdSignedInt opt_socket_timeout = 60;
+OFTimeValue opt_dimse_timeout = 0;
+OFTimeValue opt_acse_timeout = 30;
+OFTimeValue opt_socket_timeout = 60;
 
 #ifdef WITH_ZLIB
 static OFCmdUnsignedInt opt_compressionLevel = 0;
@@ -498,27 +498,31 @@
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        dcmConnectionTimeout.set(OFstatic_cast(Sint32, opt_timeout));
+        dcmConnectionTimeout.set(OFstatic_cast(OFTimeValue, opt_timeout));
       }
 
       if (cmd.findOption("--socket-timeout"))
-        app.checkValue(cmd.getValueAndCheckMin(opt_socket_timeout, -1));
+      {
+        OFCmdSignedInt opt_timeout = 0;
+        app.checkValue(cmd.getValueAndCheckMin(opt_timeout, -1));
+        opt_socket_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
+      }
       // always set the timeout values since the global default might be different
-      dcmSocketSendTimeout.set(OFstatic_cast(Sint32, opt_socket_timeout));
-      dcmSocketReceiveTimeout.set(OFstatic_cast(Sint32, opt_socket_timeout));
+      dcmSocketSendTimeout.set(OFstatic_cast(OFTimeValue, opt_socket_timeout));
+      dcmSocketReceiveTimeout.set(OFstatic_cast(OFTimeValue, opt_socket_timeout));
 
       if (cmd.findOption("--acse-timeout"))
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        opt_acse_timeout = OFstatic_cast(int, opt_timeout);
+        opt_acse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
       }
 
       if (cmd.findOption("--dimse-timeout"))
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        opt_dimse_timeout = OFstatic_cast(int, opt_timeout);
+        opt_dimse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
         opt_blockMode = DIMSE_NONBLOCKING;
       }
 
@@ -1307,8 +1311,8 @@
 static int
 secondsSince1970()
 {
-  time_t t = time(NULL);
-  return OFstatic_cast(int, t);
+  OFTimeValue t = time(NULL);
+  return OFstatic_cast(OFTimeValue, t);
 }
 
 static OFString
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/include/dcmtk/dcmnet/assoc.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/include/dcmtk/dcmnet/assoc.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/include/dcmtk/dcmnet/assoc.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/include/dcmtk/dcmnet/assoc.h	2017-12-18 10:01:06.739834102 +0100
@@ -267,7 +267,7 @@
 DCMTK_DCMNET_EXPORT OFCondition ASC_initializeNetwork(
     T_ASC_NetworkRole role,
     int acceptorPort,
-    int timeout,
+    OFTimeValue timeout,
     T_ASC_Network ** network,
     unsigned long options = 0);
 
@@ -540,15 +540,15 @@
  */
 
 DCMTK_DCMNET_EXPORT OFBool
-ASC_associationWaiting(T_ASC_Network * network, int timeout);
+ASC_associationWaiting(T_ASC_Network * network, OFTimeValue timeout);
 
 DCMTK_DCMNET_EXPORT OFBool
-ASC_dataWaiting(T_ASC_Association * association, int timeout);
+ASC_dataWaiting(T_ASC_Association * association, OFTimeValue timeout);
 
 DCMTK_DCMNET_EXPORT OFBool
 ASC_selectReadableAssociation(
     T_ASC_Association* assocs[],
-    int assocCount, int timeout);
+    int assocCount, OFTimeValue timeout);
 
 /*
  * Association Messages
@@ -562,7 +562,7 @@
     void **associatePDU=NULL,
     unsigned long *associatePDUlength=NULL,
     DUL_BLOCKOPTIONS block=DUL_BLOCK,
-    int timeout=0);
+    OFTimeValue timeout=0);
 
 DCMTK_DCMNET_EXPORT OFCondition
 ASC_receiveAssociation(
@@ -573,7 +573,7 @@
     unsigned long *associatePDUlength=NULL,
     OFBool useSecureLayer=OFFalse,
     DUL_BLOCKOPTIONS block=DUL_BLOCK,
-    int timeout=0);
+    OFTimeValue timeout=0);
 
 DCMTK_DCMNET_EXPORT OFCondition
 ASC_acknowledgeAssociation(
@@ -598,7 +598,7 @@
 ASC_abortAssociation(T_ASC_Association * association);
 
 DCMTK_DCMNET_EXPORT OFCondition
-ASC_dropSCPAssociation(T_ASC_Association * association, int timeout = DUL_TIMEOUT);
+ASC_dropSCPAssociation(T_ASC_Association * association, OFTimeValue timeout = DUL_TIMEOUT);
 
 DCMTK_DCMNET_EXPORT OFCondition
 ASC_dropAssociation(T_ASC_Association * association);
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/include/dcmtk/dcmnet/dcmtrans.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/include/dcmtk/dcmnet/dcmtrans.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/include/dcmtk/dcmnet/dcmtrans.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/include/dcmtk/dcmnet/dcmtrans.h	2017-12-18 09:59:42.311584772 +0100
@@ -41,7 +41,7 @@
  *  disables the call of the corresponding setsockopt() function, so that the
  *  system's default behavior remains unchanged.
  */
-extern DCMTK_DCMNET_EXPORT OFGlobal<Sint32> dcmSocketSendTimeout;   /* default: 60 */
+extern DCMTK_DCMNET_EXPORT OFGlobal<OFTimeValue> dcmSocketSendTimeout;   /* default: 60 */
 
 /** Global timeout in seconds for receiving data on a socket from a remote host.
  *  The default value is 60, which is useful in cases where the receiver (e.g.
@@ -51,7 +51,7 @@
  *  disables the call of the corresponding setsockopt() function, so that the
  *  system's default behavior remains unchanged.
  */
-extern DCMTK_DCMNET_EXPORT OFGlobal<Sint32> dcmSocketReceiveTimeout;   /* default: 60 */
+extern DCMTK_DCMNET_EXPORT OFGlobal<OFTimeValue> dcmSocketReceiveTimeout;   /* default: 60 */
 
 /** this class represents a TCP/IP based transport connection
  *  which can be a transparent TCP/IP socket communication or a
@@ -137,7 +137,7 @@
    *     If this parameter is 0, the function does not block.
    *  @returns OFTrue if data is available, OFFalse otherwise.
    */
-  virtual OFBool networkDataAvailable(int timeout) = 0;
+  virtual OFBool networkDataAvailable(OFTimeValue timeout) = 0;
 
   /** returns OFTrue if this connection is a transparent TCP connection,
    *  OFFalse if the connection is a secure connection.
@@ -177,7 +177,7 @@
    *  @return OFTrue if one or more connections are readable upon return from
    *    this method, OFFalse if no connection is ready for reading.
    */
-  static OFBool selectReadableAssociation(DcmTransportConnection *connections[], int connCount, int timeout);
+  static OFBool selectReadableAssociation(DcmTransportConnection *connections[], int connCount, OFTimeValue timeout);
 
 protected:
 
@@ -215,7 +215,7 @@
    *  @return OFTrue if one or more connections are readable upon return from
    *    this method, OFFalse if no connection is ready for reading.
    */
-  static OFBool safeSelectReadableAssociation(DcmTransportConnection *connections[], int connCount, int timeout);
+  static OFBool safeSelectReadableAssociation(DcmTransportConnection *connections[], int connCount, OFTimeValue timeout);
 
   /** indicates which of the specified transport connections is ready for
    *  reading. If none of the specified transport connections is ready
@@ -233,7 +233,7 @@
    *  @return OFTrue if one or more connections are readable upon return from
    *    this method, OFFalse if no connection is ready for reading.
    */
-  static OFBool fastSelectReadableAssociation(DcmTransportConnection *connections[], int connCount, int timeout);
+  static OFBool fastSelectReadableAssociation(DcmTransportConnection *connections[], int connCount, OFTimeValue timeout);
 
   /// the socket file descriptor/handle used by the transport connection.
   DcmNativeSocketType theSocket;
@@ -321,7 +321,7 @@
    *     If this parameter is 0, the function does not block.
    *  @returns OFTrue if data is available, OFFalse otherwise.
    */
-  virtual OFBool networkDataAvailable(int timeout);
+  virtual OFBool networkDataAvailable(OFTimeValue timeout);
 
   /** returns OFTrue if this connection is a transparent TCP connection,
    *  OFFalse if the connection is a secure connection.
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/include/dcmtk/dcmnet/dfindscu.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/include/dcmtk/dcmnet/dfindscu.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/include/dcmtk/dcmnet/dfindscu.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/include/dcmtk/dcmnet/dfindscu.h	2017-12-18 09:59:24.521476478 +0100
@@ -168,7 +168,7 @@
    *  @param acse_timeout timeout for ACSE operations, in seconds
    *  @return EC_Normal if successful, an error code otherwise
    */
-  OFCondition initializeNetwork(int acse_timeout);
+  OFCondition initializeNetwork(OFTimeValue acse_timeout);
 
   /** enable user-defined transport layer. This method is needed when
    *  the network association should use a non-default transport layer
@@ -237,7 +237,7 @@
     const char *abstractSyntax,
     E_TransferSyntax preferredTransferSyntax,
     T_DIMSE_BlockingMode blockMode,
-    int dimse_timeout,
+    OFTimeValue dimse_timeout,
     Uint32 maxReceivePDULength,
     OFBool secureConnection,
     OFBool abortAssociation,
@@ -304,7 +304,7 @@
     int repeatCount,
     const char *abstractSyntax,
     T_DIMSE_BlockingMode blockMode,
-    int dimse_timeout,
+    OFTimeValue dimse_timeout,
     OFBool extractResponsesToFile,
     int cancelAfterNResponses,
     OFList<OFString> *overrideKeys,
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/include/dcmtk/dcmnet/dimse.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/include/dcmtk/dcmnet/dimse.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/include/dcmtk/dcmnet/dimse.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/include/dcmtk/dcmnet/dimse.h	2017-12-18 09:59:55.810650112 +0100
@@ -662,7 +662,7 @@
         /* in */
         T_ASC_Association *assoc, DIC_US msgId,
         /* blocking info for response */
-        T_DIMSE_BlockingMode blockMode, int timeout,
+        T_DIMSE_BlockingMode blockMode, OFTimeValue timeout,
         /* out */
         DIC_US *status, DcmDataset **statusDetail);
 
@@ -710,7 +710,7 @@
         const char *imageFileName, DcmDataset *imageDataSet,
         DIMSE_StoreUserCallback callback, void *callbackData,
         /* blocking info for response */
-        T_DIMSE_BlockingMode blockMode, int timeout,
+        T_DIMSE_BlockingMode blockMode, OFTimeValue timeout,
         /* out */
         T_DIMSE_C_StoreRSP *response,
         DcmDataset **statusDetail,
@@ -738,7 +738,7 @@
     DcmDataset **imageDataSet,
         DIMSE_StoreProviderCallback callback, void *callbackData,
         /* blocking info for data set */
-        T_DIMSE_BlockingMode blockMode, int timeout);
+        T_DIMSE_BlockingMode blockMode, OFTimeValue timeout);
 
 DCMTK_DCMNET_EXPORT OFCondition
 DIMSE_sendStoreResponse(T_ASC_Association * assoc,
@@ -769,7 +769,7 @@
         T_DIMSE_C_FindRQ *request, DcmDataset *requestIdentifiers,
         DIMSE_FindUserCallback callback, void *callbackData,
         /* blocking info for response */
-        T_DIMSE_BlockingMode blockMode, int timeout,
+        T_DIMSE_BlockingMode blockMode, OFTimeValue timeout,
         /* out */
         T_DIMSE_C_FindRSP *response, DcmDataset **statusDetail);
 
@@ -791,7 +791,7 @@
         T_DIMSE_C_FindRQ *request,
         DIMSE_FindProviderCallback callback, void *callbackData,
         /* blocking info for data set */
-        T_DIMSE_BlockingMode blockMode, int timeout);
+        T_DIMSE_BlockingMode blockMode, OFTimeValue timeout);
 
 DCMTK_DCMNET_EXPORT OFCondition
 DIMSE_sendFindResponse(T_ASC_Association * assoc,
@@ -822,7 +822,7 @@
         DcmDataset *requestIdentifiers,
         DIMSE_MoveUserCallback callback, void *callbackData,
         /* blocking info for response */
-        T_DIMSE_BlockingMode blockMode, int timeout,
+        T_DIMSE_BlockingMode blockMode, OFTimeValue timeout,
         /* sub-operation provider callback */
         T_ASC_Network *net,
         DIMSE_SubOpProviderCallback subOpCallback, void *subOpCallbackData,
@@ -848,7 +848,7 @@
         T_DIMSE_C_MoveRQ *request,
         DIMSE_MoveProviderCallback callback, void *callbackData,
         /* blocking info for data set */
-        T_DIMSE_BlockingMode blockMode, int timeout);
+        T_DIMSE_BlockingMode blockMode, OFTimeValue timeout);
 
 DCMTK_DCMNET_EXPORT OFCondition
 DIMSE_sendMoveResponse(T_ASC_Association * assoc,
@@ -878,7 +878,7 @@
         DcmDataset *requestIdentifiers,
         DIMSE_GetUserCallback callback, void *callbackData,
         /* blocking info for response */
-        T_DIMSE_BlockingMode blockMode, int timeout,
+        T_DIMSE_BlockingMode blockMode, OFTimeValue timeout,
         /* sub-operation provider callback */
         T_ASC_Network *net,
         DIMSE_SubOpProviderCallback subOpCallback, void *subOpCallbackData,
@@ -903,7 +903,7 @@
         T_DIMSE_C_GetRQ *request,
         DIMSE_GetProviderCallback callback, void *callbackData,
         /* blocking info for data set */
-        T_DIMSE_BlockingMode blockMode, int timeout);
+        T_DIMSE_BlockingMode blockMode, OFTimeValue timeout);
 
 DCMTK_DCMNET_EXPORT OFCondition
 DIMSE_sendGetResponse(T_ASC_Association * assoc,
@@ -962,7 +962,7 @@
 DCMTK_DCMNET_EXPORT OFCondition
 DIMSE_receiveCommand(T_ASC_Association *association,
                      T_DIMSE_BlockingMode blocking,
-                     int timeout,
+                     OFTimeValue timeout,
                      T_ASC_PresentationContextID *presID,
                      T_DIMSE_Message *msg,
                      DcmDataset **statusDetail,
@@ -971,7 +971,7 @@
 DCMTK_DCMNET_EXPORT OFCondition
 DIMSE_receiveDataSetInMemory(T_ASC_Association *association,
                      T_DIMSE_BlockingMode blocking,
-                     int timeout,
+                     OFTimeValue timeout,
                      T_ASC_PresentationContextID *presID,
                      DcmDataset **dataObject,
                      DIMSE_ProgressCallback callback,
@@ -990,7 +990,7 @@
 
 DCMTK_DCMNET_EXPORT OFCondition
 DIMSE_receiveDataSetInFile(T_ASC_Association *assoc,
-                     T_DIMSE_BlockingMode blocking, int timeout,
+                     T_DIMSE_BlockingMode blocking, OFTimeValue timeout,
                      T_ASC_PresentationContextID *presID,
                      DcmOutputStream *filestream,
                      DIMSE_ProgressCallback callback, void *callbackData);
@@ -998,7 +998,7 @@
 DCMTK_DCMNET_EXPORT OFCondition
 DIMSE_ignoreDataSet( T_ASC_Association * assoc,
                      T_DIMSE_BlockingMode blocking,
-                     int timeout,
+                     OFTimeValue timeout,
                      DIC_UL * bytesRead,
                      DIC_UL * pdvCount);
 
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/include/dcmtk/dcmnet/dul.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/include/dcmtk/dcmnet/dul.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/include/dcmtk/dcmnet/dul.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/include/dcmtk/dcmnet/dul.h	2017-12-18 10:01:41.378579710 +0100
@@ -88,7 +88,7 @@
 /** Global timeout in seconds for connecting to remote hosts.
  *  Default value is -1, which selects infinite timeout, i.e. blocking connect().
  */
-extern DCMTK_DCMNET_EXPORT OFGlobal<Sint32> dcmConnectionTimeout;   /* default: -1 */
+extern DCMTK_DCMNET_EXPORT OFGlobal<OFTimeValue> dcmConnectionTimeout;   /* default: -1 */
 
 /** This global flag allows to set an already opened socket file descriptor which
  *  will be used by dcmnet the next time receiveTransportConnectionTCP() is called.
@@ -402,7 +402,7 @@
 DUL_InitializeNetwork(
   const char *mode,
   void *param,
-  int timeout,
+  OFTimeValue timeout,
   unsigned long
   options,
   DUL_NETWORKKEY ** network);
@@ -411,7 +411,7 @@
 DUL_ReceiveAssociationRQ(
   DUL_NETWORKKEY ** network,
   DUL_BLOCKOPTIONS block,
-  int timeout,
+  OFTimeValue timeout,
   DUL_ASSOCIATESERVICEPARAMETERS * parameters,
   DUL_ASSOCIATIONKEY ** association,
   int activatePDUStorage);
@@ -426,7 +426,7 @@
 DUL_RequestAssociation(
   DUL_NETWORKKEY ** network,
   DUL_BLOCKOPTIONS block,
-  int timeout,
+  OFTimeValue timeout,
   DUL_ASSOCIATESERVICEPARAMETERS * params,
   DUL_ASSOCIATIONKEY ** association,
   int activatePDUStorage);
@@ -443,7 +443,7 @@
 */
 DCMTK_DCMNET_EXPORT OFCondition
 DUL_ReadPDVs(DUL_ASSOCIATIONKEY ** association,
-       DUL_PDVLIST * pdvList, DUL_BLOCKOPTIONS block, int timeout);
+       DUL_PDVLIST * pdvList, DUL_BLOCKOPTIONS block, OFTimeValue timeout);
 DCMTK_DCMNET_EXPORT OFCondition
 DUL_WritePDVs(DUL_ASSOCIATIONKEY ** association,
         DUL_PDVLIST * pdvList);
@@ -474,12 +474,12 @@
 */
 
 DCMTK_DCMNET_EXPORT OFBool
-DUL_dataWaiting(DUL_ASSOCIATIONKEY * callerAssociation, int timeout);
+DUL_dataWaiting(DUL_ASSOCIATIONKEY * callerAssociation, OFTimeValue timeout);
 
 DCMTK_DCMNET_EXPORT DcmNativeSocketType DUL_networkSocket(DUL_NETWORKKEY * callerNet);
 
 DCMTK_DCMNET_EXPORT OFBool
-DUL_associationWaiting(DUL_NETWORKKEY * callerNet, int timeout);
+DUL_associationWaiting(DUL_NETWORKKEY * callerNet, OFTimeValue timeout);
 
 /*
  * functions allowing to retrieve raw A-ASSOCIATE PDUs from the DUL layer
